<template>
  <div>
    <div id="sidebar">
      <recent-violations :violations="violations" />
      <div id="headlines">
        <headlines />
      </div>
      <action-buttons
        :has-swiper="hasSwiper"
        :shop="shop" />
    </div>
    <div id="suggestion-box" class="clearfix">
      <div id="maincontent">
        <h1>Suggestion Box</h1>
        <section>
          <section
            v-show="!suggestions.length"
            class="notice">
            <p>There are currently no suggestions.</p>
          </section>
          <table v-show="suggestions.length">
            <thead>
              <tr>
                <th>Name</th>
                <th>Suggestion</th>
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="suggestion in suggestions" :key="suggestion.id">
                <td>{{ suggestion.submitter }}</td>
                <td>{{ suggestion.body }}</td>
              </tr>
            </tbody>
          </table>
        </section>
      </div>
    </div>
  </div>
</template>

<script>
import RecentViolations from "./components/RecentViolation.vue";
import Headlines from "../Headlines.vue";
import ActionButtons from "../ActionButtons.vue";

export default {
  components: {
    RecentViolations,
    Headlines,
    ActionButtons,
  },
  props: {
    suggestions: Array,
    violations: Array,
    shop: Object,
    hasSwiper: Boolean,
  },
  methods: {
    putViewedSuggestions() {
      app.session.SetSession()
        .then( () => {
          //editing the isViewed key in the db, no payload needed.
          app.api.Put(`townehall/putViewedSuggestions/${app.session.data.id}`)
          .then(Response => {
            // app.Message(Response, "success");
          })
          .catch( x => app.Message(x.error, "error"));
        })
    }
  },
  mounted: function () {
    this.putViewedSuggestions();
  },
  destroyed: function () {
    this.putViewedSuggestions();
  }
}
</script>
